Page 60,132
;Determine amount of available RAM without using CHKDSK
;Compatible with:
; Turbo ASseMbler version 1.0 and
; Microsoft ASseMbler version 5.10
;
; Assemble:  TASM SAMPLE
; Link:      TLINK /T SAMPLE
;
cseg    Segment public para
        Assume  CS:CSEG, DS:CSEG, ES:CSEG
        Org     100H
freeram Proc    near
start:  Mov     ax,CS:[2]       ;Offset 2 contains total memory size
        Mov     bx,CS
        Sub     ax,bx           ;Minus our psp segment = memory available
;convert paragraphs to a doubleword number of bytes in dx:ax
        xor     dx,dx
        mov     dl,ah           ;dl will contain top four bytes of ah
        mov     cl,4
        shr     dx,cl
        shl     ax,cl
;convert doubleword to a six char ASCII number
        MOv     bx,offset nbyts+7
        MOv     cx,offset nbyts+3
        MOv     si,10           ;prepare to divide by 10
nexdgt: DIv     si              ;divide dx:ax by si
        OR      dx,30H          ;convert remainder to ASCII digit
        DEc     bx              ;back up one space in buffer
        CMp     bx,cx           ;if not at comma
        JNz     nocma           ;store character
         dec    bx              ;else back up one space and
nocma:  mov     [bx],dl         ;store character
        xor     dx,dx           ;clear remainder
        or      ax,ax           ;all done?
        jnz     nexdgt          ;do next digit
;now output the string
        mov     dx,offset bmess$
        mov     ah,09H
        int     21H             ;print string
;exit
        mOV     ax,4C00H
        iNT     21H
freeram endp
;data area
bmess$  db      13,10,'Free Ram: '
nbyts   db      32,32,32,',',32,32,32 ;holds ASCII digit
        db      ' bytes',13,10,36

cseg    ends
end     start
